# Bobbapp: Infrastructure and deployment

In this project, you'll find configuration files and script(s) used by `terraform`, `helm` and `kubectl` tools to provision and set up a Kubernetes cluster on Google Kubernetes Engine. All the required steps will be executed by a pipeline that is associated with this project (see `.gitlab-ci.yml`).

## The big picture

Below you see the overall architecture of the delivery. Developers can independently work on their code and each commit on the remote repository triggers a pipeline that builds and publishes an image to Google's Container Registry. Other than this CI part, there are two main projects in the `env` group that maintain the current state on both infrastructure (on GCP) and platform (in the Kubernetes cluster) level. For the first one, we use Terraform resources to do so and for the other one, we use Helm templates (please see the [config project](https://gitlab.com/azizos/bobbapp/env/config/)). See the image below:

![](docs/assets/architecture.png "Project architecture")


## Automation
By providing the right environment variables on project level (_see below_) and running the pipeline a number of steps will be executed that can be categorized in the following logical parts:

### Provision
In the `terraform` directory, you'll find `.tf` files that will be used to create a new Kubernetes cluster on Google's Kubernetes Engine. A GCP service account with right permissions is, therefore, required to allow Terraform to perform all necessary tasks. This step consists of two stages (in the pipeline): `terraform plan`, that checks the current state in the infrastructure (using a [GCS backend](https://www.terraform.io/docs/backends/types/gcs.html), and `terraform apply` that applies all changes to the cloud.

### Setup
Regardless of whether `terraform apply` fails or not, we can manually trigger the next stage that runs a Bash script (stored in `k8s` directory as `setup.sh` file) that connects to the cluster (if exists) and executes the following tasks (divided into two stages in the pipeline):

- Installs [fluxcd](https://github.com/fluxcd/flux-get-started) and its [helm-operator](https://github.com/fluxcd/helm-operator-get-started) to enable GitOps on images and application's Helm chart stored in [here](https://gitlab.com/azizos/bobbapp/env/config/)
- Installs [SealedSecrets controller](https://github.com/bitnami-labs/sealed-secrets#helm-chart) to decrypt secret resources structured in the application's Helm chart on Git. _Please note: we're also injecting a custom key-pair into the controller and avoid the one that automatically gets generated by the SealedSecrets controller, for reusability and consistency reasons.
- Downloads and applies the application's most recent `HelmRelease` resource required by the. HelmOperator to clone the application's Helm chart and install it. Note: this task has a separate stage in order to manage the application deployment separately. However, it will only trigger if the previous stage (setup) has completed successfully.

## Requirements

In order to use this project and be able to perform the steps described above, you'd first want to have the following environment variables available (_you can add them on Settings > CI / CD_):

| Variable                 | Description                                                                                                              |
|--------------------------|--------------------------------------------------------------------------------------------------------------------------|
| BOBBAPP_CONFIG_GIT_ID    | The ID of the (Gitlab) repository containing the application's Helm chart. Used to upload Flux public key as deploy key  |
| BOBBAPP_CONFIG_GIT_URL   | The GIT URL to the repository containing the application's Helm chart. Passed as an argument to Flux controller          |
| BOBBAPP_HELMRELEASE_LINK | The link to the HelmRelease file stored on the `config` repository. Used by HelmOperator to install application's charts |
| BOBBAPP_SEALED_SECRET    | Encrypted custom SealedSecrets key-pair used to decrypt secrets stored on `config` repository                            |
| GCP_CREDENTIALS          | Encrypted GCP service account that allows to create Storage objects and manage GKE clusters                              |
| GITLAB_PRIVATE_TOKEN     | GitLab's personal private token to do REST calls (to upload Deploy Key, see above)                                       |
| TF_VAR_cluster_name      | The name of Kubernetes cluster to be created and configured                                                              |
| TF_VAR_project           | The name of an existing GCP project to configure the cluster on                                                          |
| TF_VAR_region            | The a GCP region to configure the cluster on                                                                             |

## Notes 
We're using a custom image in the pipeline. The image (to be found [here](https://gitlab.com/azizos/bobbapp/env/tools/tf-helm-image)) includes all the packages needed to make the pipeline run its commands. To learn more about which packages it contains and what versions, please see the images `Dockerfile` in the link above.

Fruther, at the moment, there's no separation between different deployment environments (like dev, prod or staging) and we're always targeting master branches (both on application level and config level). It's not a good practice, but the setup is flexible enough to implement those modifications too. Please note this is a demo project and not suitable for production cases.